<template>
  <div @click="expand()" class="" :class="showDetail ? 'py-2' : 'clickable'" ref="rootElement">
    <div
      class="border bg-white px-4 py-4"
      :class="{
        'p-4 shadow-md': showDetail,
        '-mx-2 border-l-0 border-r-0': showDetail && thin,
        rounded: !showDetail || (showDetail && !thin)
      }"
    >
      <div class="flex flex-row items-center justify-between">
        <!-- State -->
        <done-indicator :task="task" class="mr-4 float-left"></done-indicator>

        <!-- Title -->
        <task-title-input
          v-if="showDetail"
          @keyup.enter="$emit('title-enter', $event)"
          ref="titleinput"
          class="w-full"
          :value="task.title"
          @input="task.title = $event.target.value"
        />
        <div v-if="!showDetail" class="w-full flex flex-row items-baseline justify-start">
          <div v-if="task.isPending()" class="text-blue-500 text-sm">
            <i v-if="task.isPostponed" class="hero chevron-double-right solid"></i>
            <i v-else-if="task.isWaiting" class="hero clock solid"></i>
          </div>
          <div :class="`${task.isDone() ? 'text-gray-600 line-through' : ''} ml-1`">
            {{ task.title }}
          </div>
        </div>
        <div
          v-if="!showDetail && task.isOverdue()"
          class="flex flex-row items-center text-xs whitespace-no-wrap text-red-500 font-bold"
        >
          <i :class="`hero ${task.isDate ? 'calendar' : 'flag'} solid mr-1`"></i>
          {{ task.overdueSince()?.as("days") }} days ago
        </div>
        <div
          v-else-if="!showDetail && task.isToday()"
          class="flex flex-row items-center text-xs whitespace-no-wrap text-blue-500 font-bold"
        >
          <i :class="`hero ${task.isDate ? 'calendar' : 'flag'} solid mr-1`"></i>
          today
        </div>
        <div
          v-if="!showDetail && task.isTomorrow()"
          class="flex flex-row items-center text-xs whitespace-no-wrap text-orange-500 font-bold"
        >
          <i :class="`hero ${task.isDate ? 'calendar' : 'flag'} solid mr-1`"></i>
          tomorrow
        </div>

        <today-indicator
          v-if="((!hideFocus && !task.isDone()) || showDetail) && !task.workspace().execSync().isInbox"
          :key="`${task.id}:today`"
          :task="task"
          class="ml-4"
        />
        <i
          v-if="showDetail"
          :key="`${task.id}:close`"
          @click.stop="collapse()"
          class="hero x solid text-gray-600 text-sm clickable-bg rounded-full p-2 -mr-2 -my-2 ml-2"
        ></i>
      </div>

      <div
        v-if="!showDetail && workspace"
        style="margin-left: 1.95em"
        class="mt-1 flex flex-row items-center justify-start"
      >
        <workspaces-indicator :value="task.workspace().execSync()" />
      </div>

      <div v-if="showDetail" class="pt-2">
        <task-description :value="task.description" @input="task.description = $event" class="ml-8" />
        <div
          v-if="task.isDeadlined"
          @click="modals.show('deadline-picker')"
          class="flex flex-row items-center text-sm ml-2 mt-4"
        >
          <i
            class="hero solid flag mr-2 text-gray-400"
            :class="{
              'text-blue-500': task.isDeadlineToday(),
              'text-red-500': task.isDeadlineOverdue()
            }"
          ></i>
          <div class="text-gray-500">Deadline {{ task.isDeadlineToday() ? "" : "at" }}</div>
          <div
            class="ml-1 flex-1"
            :class="{
              'text-blue-600': !task.isDeadlineOverdue(),
              'text-red-500': task.isDeadlineOverdue()
            }"
          >
            {{
              task.isDeadlineToday()
                ? "today"
                : task.deadlineAt.toLocaleString({ weekday: "short", month: "short", day: "2-digit" })
            }}
          </div>
          <i
            @click.stop="task.$setAndSaveAttributes({ deadlineAt: null })"
            class="hero solid x text-gray-500 clickable"
          ></i>
        </div>
        <div
          v-if="task.remindAt"
          @click="modals.show('reminder-picker', $event)"
          class="flex flex-row items-center text-sm ml-2 mt-4 clickable"
        >
          <i class="hero solid bell mr-2 text-blue-500"></i>
          <div class="text-gray-500">Reminder at</div>
          <div class="ml-1 flex-1 text-blue-600">
            {{
              task.remindAt.toLocaleString({
                weekday: "short",
                month: "short",
                day: "2-digit",
                hour: "2-digit",
                minute: "2-digit"
              })
            }}
          </div>
          <i
            @click.stop="task.$setAndSaveAttributes({ remindAt: null })"
            class="hero solid x text-gray-500 clickable"
          ></i>
          <modal :is="modals.inlined('reminder-picker')" v-slot="{ modal }" dimmed position="center">
            <date-time-picker
              :value="task.remindAt"
              @cancel="modal.hide()"
              @input="
                task.$setAndSaveAttributes({ remindAt: $event });
                modal.hide();
                Push.ensure();
              "
            />
          </modal>
        </div>
        <!-- Task footer -->
        <div class="flex flex-row items-center justify-between mt-4">
          <!-- Hide postpone etc in inbox -->
          <div v-if="task.workspace().execSync().isInbox"></div>
          <!-- Today marker -->
          <horizontal-scrolling v-else-if="task.isDate && task.isDeadlineToday()">
            <div
              @click="modals.show('date-picker')"
              class="border rounded-full px-3 py-1 flex flex-row items-center whitespace-no-wrap text-sm text-blue-500 bg-blue-100 clickable-bg"
            >
              <i class="hero solid calendar mr-2 text-blue-500"></i>
              Scheduled for today
              <i
                @click.stop="task.$setAndSaveAttributes({ deadlineAt: null, postponedUntil: null })"
                class="hero solid x text-blue-500 ml-2 -mr-1 clickable"
              ></i>
            </div>
          </horizontal-scrolling>
          <horizontal-scrolling v-else-if="task.isDate && task.isDeadlineOverdue()">
            <div
              @click="modals.show('date-picker')"
              class="border rounded-full px-3 py-1 flex flex-row items-center whitespace-no-wrap text-sm text-red-500 bg-red-100 clickable-bg"
            >
              <i class="hero solid calendar mr-2 text-red-500"></i>
              Scheduled for
              {{ task.postponedUntil.toLocaleString({ weekday: "short", month: "short", day: "2-digit" }) }}
              <i
                @click.stop="task.$setAndSaveAttributes({ deadlineAt: null, postponedUntil: null })"
                class="hero solid x text-red-500 ml-2 -mr-1 clickable"
              ></i>
            </div>
          </horizontal-scrolling>
          <horizontal-scrolling v-else-if="task.isDo()" class="mr-2">
            <div
              @click="modals.show('postponed-picker')"
              class="border rounded-full px-3 py-1 flex flex-row items-center whitespace-no-wrap text-sm text-gray-800 clickable-bg"
            >
              <i class="hero solid chevron-double-right text-blue-500 mr-1"></i>
              Postpone
            </div>
            <div
              @click="modals.show('waiting-picker')"
              class="border rounded-full px-3 py-1 flex flex-row items-center whitespace-no-wrap text-sm text-gray-800 ml-1 clickable-bg"
            >
              <i class="hero solid clock text-blue-500 mr-2"></i>
              Wait
            </div>
            <div
              @click="modals.show('date-picker')"
              class="border rounded-full px-3 py-1 flex flex-row items-center whitespace-no-wrap text-sm text-gray-800 ml-1 clickable-bg"
            >
              <i class="hero solid calendar text-blue-500 mr-2"></i>
              Schedule
            </div>
          </horizontal-scrolling>
          <horizontal-scrolling v-else-if="task.isPending() && task.isDate">
            <div
              @click="modals.show('date-picker')"
              class="border rounded-full px-3 py-1 flex flex-row items-center whitespace-nowrap text-sm text-gray-800 clickable-bg"
            >
              <i class="hero solid calendar mr-2 text-blue-500"></i>
              Scheduled for {{ task.deadlineAt.toLocaleString({ weekday: "short", month: "short", day: "2-digit" }) }}
              <i
                @click.stop="task.$setAndSaveAttributes({ deadlineAt: null, postponedUntil: null })"
                class="hero solid x text-gray-500 ml-2 -mr-1 clickable"
              ></i>
            </div>
          </horizontal-scrolling>
          <horizontal-scrolling v-else-if="task.isPending() && task.isWaiting">
            <div
              @click="modals.show('waiting-picker')"
              class="border rounded-full px-3 py-1 flex flex-row items-center whitespace-no-wrap text-sm text-gray-800 clickable-bg"
            >
              <i class="hero solid clock mr-2 text-blue-500 -ml-1"></i>
              Waiting for
              {{ task.waitingFor }}
              <div v-if="task.postponedUntil" class="ml-1">
                until
                {{ task.postponedUntil.toLocaleString({ weekday: "short", month: "short", day: "2-digit" }) }}
              </div>
              <i
                @click.stop="task.$setAndSaveAttributes({ waitingFor: null, postponedUntil: null })"
                class="hero solid x text-gray-500 ml-2 -mr-1 clickable"
              ></i>
            </div>
          </horizontal-scrolling>
          <horizontal-scrolling v-else-if="task.isPending() && task.isPostponed">
            <div
              @click="modals.show('postponed-picker', $event)"
              class="border rounded-full px-3 py-1 flex flex-row items-center whitespace-nowrap text-sm text-gray-800 clickable-bg"
            >
              <i class="hero solid chevron-double-right mr-2 text-blue-500 -ml-1"></i>
              Postponed until
              {{ task.postponedUntil.toLocaleString({ weekday: "short", month: "short", day: "2-digit" }) }}
              <i
                @click.stop="task.$setAndSaveAttributes({ deadlineAt: null, postponedUntil: null })"
                class="hero solid x text-gray-500 ml-2 -mr-1 clickable"
              ></i>
            </div>
          </horizontal-scrolling>
          <div v-else></div>
          <div class="flex flex-row items-center justify-end">
            <i
              v-if="task.$isPersistent"
              @click="modals.show('tasks-options-modal', $event)"
              class="hero dots-vertical outline text-gray-600 clickable-bg rounded-full -m-2 p-2"
            ></i>
            <div v-else class="button" @click="save()">Save</div>
          </div>
        </div>
        <modal :is="modals.get('tasks-options-modal')" :task="task" />
        <modal :is="modals.get('deadline-picker')" :task="task" />
        <modal :is="modals.get('postponed-picker')" :task="task" />
        <modal :is="modals.get('waiting-picker')" :task="task" />
        <modal :is="modals.get('date-picker')" :task="task" />
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import Task from "@/models/Task";
import router from "@/router";

import DoneIndicator from "@/components/Done/Indicator.vue";
import TodayIndicator from "@/components/Today/Indicator.vue";
import WorkspacesIndicator from "@/components/Workspaces/Indicator.vue";
import TasksOptionsModal from "@/components/Tasks/TasksOptionsModal.vue";
import TaskTitleInput from "@/components/Tasks/TaskTitleInput.vue";
import TaskPostponedIndicator from "@/components/Tasks/TaskPostponedIndicator.vue";
import TaskDeadlinedIndicator from "@/components/Tasks/TaskDeadlinedIndicator.vue";
import TaskDateIndicator from "@/components/Tasks/TaskDateIndicator.vue";
import TaskDescription from "@/components/Tasks/TaskDescription.vue";
import ToggleToday from "@/components/Tasks/Actions/ToggleToday.vue";
import Schedule from "@/components/Tasks/Actions/Schedule.vue";
import Tag from "@/components/Tag.vue";
import HorizontalScrolling from "@/components/HorizontalScrolling.vue";
import { useModals } from "@/use/modal";
import { nextTick, onMounted, onUnmounted, ref, watch } from "vue";
import responsive from "@/use/responsive";
import { closeTask, openTask, openWorkspaceFromTask } from "@/use/navigation";
import { Autosaver } from "@/use/autosaver";
import TaskDeadlinedPickerVue from "./TaskDeadlinedPicker.vue";
import TaskPostponedPickerVue from "./TaskPostponedPicker.vue";
import TaskDatePickerVue from "./TaskDatePicker.vue";
import TaskWaitPickerVue from "./TaskWaitPicker.vue";
import DateTimePicker from "../DateTimePicker.vue";
import { watchedRef } from "@/use/watchedRef";
import { Push } from "@/assets/Push";

export default {
  components: {
    DateTimePicker,
    DoneIndicator,
    Tag,
    HorizontalScrolling,
    TaskTitleInput,
    TaskDescription,
    Schedule,
    ToggleToday,
    TodayIndicator,
    WorkspacesIndicator,
    TaskPostponedIndicator,
    TaskDeadlinedIndicator,
    TaskDateIndicator
  },
  emits: ["saved", "removed", "closed", "opened", "title-enter"],
  props: {
    task: {
      type: Task,
      required: true
    },
    focus: {
      type: Boolean,
      default: false
    },
    thin: {
      type: Boolean,
      default: false
    },
    workspace: {
      type: Boolean,
      default: false
    },
    hideFocus: {
      type: Boolean,
      default: false
    },
    showStatus: {
      type: Boolean,
      default: false
    }
  },
  setup(props, context) {
    const modals = useModals({
      TasksOptionsModal,
      DeadlinePicker: TaskDeadlinedPickerVue,
      PostponedPicker: TaskPostponedPickerVue,
      DatePicker: TaskDatePickerVue,
      WaitingPicker: TaskWaitPickerVue
    });
    const titleinput = ref<HTMLElement | null>(null);
    const clicked = ref<boolean>(false);
    const rootElement = ref<HTMLElement | null>(null);

    const showDetail = watchedRef(() => router.currentRoute.value.query.task == props.task.id);
    watch(showDetail, (current, prev) => {
      if (!current && prev) {
        context.emit("closed");
      } else if (current && !prev) {
        if (clicked.value) {
          nextTick(autofocus);
          clicked.value = false;
        }
        context.emit("opened");
      }
    });

    const autofocus = () => {
      if (responsive.isDesktop || props.focus) {
        titleinput.value?.focus();
      }
    };

    const autosaver = new Autosaver(() => props.task, { timeout: 1000 });
    onMounted(() => {
      autosaver.start();
      if (props.focus) {
        autofocus();
      }
    });
    onUnmounted(() => {
      autosaver.stop();
    });

    const expand = () => {
      if (!showDetail.value) {
        openTask(props.task.id!);
        clicked.value = true;
      }
    };

    const collapse = () => {
      if (showDetail.value) {
        closeTask();
      }
    };

    const scrollIntoView = () => rootElement.value?.scrollIntoView({ block: "center", behavior: "smooth" });

    watch(showDetail, show => (show ? nextTick(() => scrollIntoView()) : null), { immediate: true });

    return {
      rootElement,
      titleinput,
      modals,
      scrollIntoView,
      save: async () => {
        await props.task.save();
        context.emit("saved");
      },
      showDetail,
      expand,
      collapse,
      openWorkspaceFromTask,
      Push
    };
  }
};
</script>

<style scoped>
.group:hover .group-hover\:flex {
  @apply flex;
}
</style>
